# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl Nuggeteer.t'

#########################

# change 'tests => 1' to 'tests => last_test_to_print';

use Test::More tests => 7;

#########################

# Insert your test code below, the Test::More module is use()ed here so read
# its man page ( perldoc Test::More ) for help writing this test script.

my $pwd=`pwd`; chomp($pwd);
my $ansfile = qq($pwd/t/official-2003.answers);
my $jdgdir = qq($pwd/t/some-2003);


my $t1 = "exact.out";
my $t2 = "bigrams-0.15-c.out";
my $u = "MITCSAIL.c-unknowns";
my $n = qq(nuggeteer.pl);

# do the exact score test: 
my $cmd = qq($n $ansfile $jdgdir/* $jdgdir/MITCSAIL03.c > t/test-$t1);
if(system($cmd)) {
    fail("trouble running [$cmd]: $@\n");
    exit 1;
} else { pass("running exact test"); }

# do the approximate score test:
$cmd = qq($n --unknowns t/test-$u --exclude --bigrams --threshold 0.15 ).
    qq($ansfile $jdgdir/* $jdgdir/MITCSAIL03.c > t/test-$t2);
if(system($cmd)) { 
    fail("trouble running [$cmd]: $@\n");
    exit 1;
} else { pass("running approximate test"); }

my $g1=`genstats.pl -b t/test-$t1 8`;
is($g1, "n= 50	col1:	0.3061 +- 0.0768\t\n", "f-measures for exact output");
my $g2=`genstats.pl -b t/test-$t2 8`;
is($g2, "n= 50	col1:	0.2685 +- 0.0769\t\n", "f-measures for approximate output");

my $diff1=`diff t/$t1 t/test-$t1`;
$diff1=~ s/^. . (this|user|host|global threshold|nuggetlistfile|judgement files|testfile|database) = .*//mg;
$diff1=~ s/^. . starting at: .*//mg;
$diff1=~ s/^[\s-]*$//mg;
$diff1=~ s/^[\d,]+[adc][\d,]+$//mg;
$diff1=~ s/\n+/\n/gs;
is($diff1, "\n", "no diff in exact output");
my $diff2=`diff t/$t2 t/test-$t2`;
$diff2=~ s/^. . (this|user|host|output unknowns to|global threshold|nuggetlistfile|judgement files|testfile|database) = .*//mg;
$diff2=~ s/^. . starting at: .*//mg;
$diff2=~ s/^[\s-]*$//mg;
$diff2=~ s/^[\d,]+[adc][\d,]+$//mg;
$diff2=~ s/\n+/\n/gs;
is($diff2, "\n", "no diff in approximate output");
my $diffu=`diff t/$u t/test-$u`;
is($diff2, "\n", "no diff in unknowns judgements");

